=pod

Module O_V.pm

A component of the checker group of programs for monitoring applications, databases, networks,
all types of servers, and more. By Nova Software, Inc.

Copyright  by Nova Software, Inc. 2018  All rights reserved.  http://www.nova-sw.com

=cut
  package O_V ; our $VERSION = 0.171117; use strict; use warnings; use sigtrap; use O_B 0.170824; use O_M 0.170824; use O_U 0.170824;
use IO::Socket;  use IO::Select; use POSIX ;  use Net::hostent; use Data::Dumper; {  my %ckV = ();  my %hzV = ();  my $kiV = time();  sub vhV { my ($evV) = @_; my $a2V = vjB.xhB().riB().'-'.O_C::lkC().'-discovery.'.kdB; my $tbV = %hzV ? '>>' : '>' ; open my $wgV, "$tbV$a2V" or warn cwM(24, $a2V, $!) ;  $kiV = time(); my $dlV = localtime $kiV ; jaV( dyM(90, APP_N_HOST(), yfB(), $dlV ) )  if $wgV; print dyM(91, w1B().xhB().$a2V)  if $wgV; my %czV = () ; 
foreach my $rvV (keys %$evV) {  next unless $rvV;  next if ( $rvV eq q1B or $rvV eq qjB ) ; next unless $evV->{$rvV}{host};  next unless $evV->{$rvV}{_hostbegin} =~/^(\d{1,3}\.)(\d{1,3}\.)(\d{1,3}\.)(\d{1,3})$/;   if (my $q2V = $evV->{$rvV}{hostrange}) { next unless $evV->{$rvV}{hostrange} < 255;  $czV{$rvV} = 1;  if (my $wsV = $hzV{$rvV} ) {  foreach my $cdV (keys %$wsV) {  warn ecM."O_V::vhV() failure:  $rvV should equal $wsV->{$cdV}{_parent}" if ($rvV ne $wsV->{$cdV}{_parent}) and next;  my %tmp = %{$evV->{$rvV}} ;  $tmp{hostrange}= ''; $tmp{_parent} = $rvV; my $tmph = $wsV->{$cdV}{host}; my $tmphb = $wsV->{$cdV}{_hostbegin}; $wsV->{$cdV} = \%tmp;  $wsV->{$cdV}{host} = $tmph; $wsV->{$cdV}{_hostbegin} = $tmphb;
} } my $vwV  = $evV->{$rvV}{_hostbegin}; my $xdV   = $evV->{$rvV}{port}; my $fgV = $evV->{$rvV}{protocol}; $ckV{$rvV}{hostrange}  ||= 0 ;  $ckV{$rvV}{_hostbegin} ||= '';  $ckV{$rvV}{port}       ||= '';  $ckV{$rvV}{protocol}   ||= '';  next if ( ($q2V   == $ckV{$rvV}{hostrange} ) and  ($vwV  eq $ckV{$rvV}{_hostbegin}) and  ($xdV   eq $ckV{$rvV}{port}      ) and  ($fgV eq $ckV{$rvV}{protocol}  ) ) ; $ckV{$rvV} = {hostrange  => $q2V, _hostbegin => $vwV, port       => $xdV, protocol   => $fgV, }; die(cwM(313, $rvV) )  if  O_C::p1C() ; 
delete $hzV{$rvV}  if exists $hzV{$rvV} ; g1V(dyM(46, $rvV), $wgV )  if $wgV; my $tmp = egV($rvV, $evV, $wgV); $hzV{$rvV} = $tmp  if %$tmp; } else {next}  } foreach (keys %hzV) { delete $hzV{$_}  unless $czV{$_}; } print $wgV "\n\n" if $wgV; close $wgV  if $wgV; return [values %hzV]; } my $lbV = '';  sub jaV { $lbV .= shift } sub g1V { my ($ydV, $xcV) = @_; my $gzV = time() - $kiV; if ($lbV) {
print $xcV $lbV; $lbV = ''; } print $xcV  $gzV." $ydV"; } } sub egV { my ($rvV, $evV, $wgV) = @_; my $dzV = substr($rvV, 0,35);  my $jpV = 0; my %yjV = ();  my ($qgV, $dbV, $cqV, $gwV) = $evV->{$rvV}{_hostbegin} =~/(\d{1,3}\.)(\d{1,3}\.)(\d{1,3}\.)(\d{1,3})/; my $llV = $evV->{$rvV}{hostrange};  while ($jpV < $llV ) { last if $gwV > 254;  my $joV = $dzV.':'.sprintf('%03u',$jpV++); my %tmp = %{$evV->{$rvV}};  $yjV{$joV} = \%tmp; $yjV{$joV}{host} = $yjV{$joV}{_hostbegin} = $qgV.$dbV.$cqV.$gwV++;  $yjV{$joV}{hostrange} = '';
$yjV{$joV}{_parent} = $rvV; } my $rcV = q1B; my $buV = $evV->{$rcV}{discoveryslowdown} ; my $wfV = $evV->{$rcV}{dsdonlyonfail} ; my $hxV = znV(\%yjV, 1, $buV, $wfV, $wgV );   return $hxV; } sub znV { my ($qoV, $sqV, $buV, $wfV, $wgV) = @_; my %upV = ();  my $gkV = $buV; foreach my $cdV (keys %$qoV) {    my $alV = pbV($cdV, $qoV, $sqV); if ($alV) {  g1V( "\t$alV\n", $wgV )  if $wgV; $gkV = $buV; } else { g1V( dyM(47, $cdV, $qoV->{$cdV}{host}), $wgV )  if $wgV;
my %tmp = %{$qoV->{$cdV}};   $upV{$cdV} = \%tmp; $gkV = $buV*(1-$wfV); } select (undef, undef, undef, $gkV)  if $gkV;   } return \%upV; } sub pbV { my ($cdV, $ywV, $sqV ) = @_; my $dvV = $ywV->{$cdV}{protocol};  $dvV = lc $dvV; my $tmp = $dvV.'_t'; no strict 'refs'; my $ydV = &{$tmp}($cdV, $ywV, $sqV); use strict; return $ydV; } our $AUTOLOAD; sub AUTOLOAD{ 
my ($cdV, $ywV, $sqV) = @_; my @tmp = split ':', $AUTOLOAD;  $tmp[2] =~s/_t$//; $tmp[2] =~s/\s//g;  my $kjV = $ywV->{$cdV}{port}; if (my $fjV = O_D::zzD($tmp[2]) ) { $kjV ||= $fjV->[0]; return xbT($cdV, $fjV->[1], $kjV, $ywV, $sqV );  } else {  return ecM.dyM(48, __PACKAGE__, $AUTOLOAD);  } } sub xbT {   my ($cdV, $nzV, $kjV, $ywV, $sqV ) = @_; return ecM.dyM(49, __PACKAGE__) unless $cdV ;  $nzV = lc $nzV; return ecM.dyM(50, __PACKAGE__, $nzV) unless ($nzV eq 'udp' or $nzV eq 'tcp') ;
return ecM.dyM(51, __PACKAGE__, $kjV) unless ($kjV !~/\D/ and $kjV > 0 and $kjV < 65536)  ; my $oqV = $ywV->{$cdV}{host}; my $mbV = IO::Socket::INET->new( PeerAddr    => $oqV, PeerPort    => $kjV, Proto       => $nzV, Type        => $nzV eq 'tcp' ? SOCK_STREAM  : SOCK_DGRAM, Timeout     => $sqV, Blocking    => 1,  ReuseAddr   => 1,  ); my $ydV = ''; if ($mbV) { $mbV->autoflush(1); undef $mbV ;  } else { $ydV = dyM(52, $cdV, $oqV, $kjV, bhB(), $nzV, "\t\t$!"); }
return $ydV; } sub END{ } 1;
__DATA__
+sBNy67XMtJQm/hOHHhRqQ

